#Adults cold tolerance: 
A<-read.table("tolerance froid ad suzukii.txt", header=T)
A$survival=(A$n-A$dead)/A$n
Fr<-na.omit(A)
attach(Fr)

Temperature=as.factor(temperature)
yadfr<-cbind(Fr$n-Fr$dead,Fr$dead)
model<-glm(yadfr~Temperature*duration*sex, family=binomial(link=logit))
library(car)
Anova(model)

########## EFFECT PLOTS 
library(effects)
### All varaibles
plot(allEffects(model))
##### Variables and intercations
plot(effect("Temperature ",model),ylab="Survival") 
plot(effect("duration ",model),ylab="Survival")         
plot(effect("sex",model),ylab="Survival")  
plot(effect("Temperature:duration",model),ylab="Survival")                          
plot(effect("Temperature:sex ",model),ylab="Survival")                         
plot(effect("duration:sex",model),ylab="Survival")                      
plot(effect("Temperature:duration:sex",model),ylab="Survival")                   

Fr$predFr=predict(model, type="response")
predFr=as.numeric(unlist(Fr$predFr))

#################
#Plots:
x11()
par(mfrow=c(2,3), mar=c(4,4,1,1))
#-5C: 
d_5male=subset(Fr,Temperature=="-5" & sex=="male")
attach(d_5male)
plot(ylim=c(0,1), xlim=c(0,2),survival~duration, data=d_5male, pch=15
     , col="black" ,lwd=1, ylab="Percentage survival", xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(1.875,0.95,"-5C",col="Black", cex=2)
lines(predFr~duration, data=d_5male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d_5female=subset(Fr,Temperature=="-5" & sex=="female")
attach(d_5female)
points(survival~duration, data=d_5female, pch=17, col="Grey40",lwd=1)
lines(predFr~duration, data=d_5female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#-2.5
d_2.5male=subset(Fr,Temperature=="-2.5" & sex=="male")
attach(d_2.5male)
plot(ylim=c(0,1), xlim=c(0,12),survival~duration, data=d_2.5male, pch=15
     , col="black" ,lwd=1, ylab="", xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(11,0.95,"-2.5C",col="Black", cex=2)
lines(predFr~duration, data=d_2.5male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d_2.5female=subset(Fr,Temperature=="-2.5" & sex=="female")
attach(d_2.5female)
points(survival~duration, data=d_2.5female, pch=17, col="Grey40",lwd=1)
lines(predFr~duration, data=d_2.5female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#0
d0male=subset(Fr,Temperature=="0" & sex=="male")
attach(d0male)
plot(ylim=c(0,1), xlim=c(0,72),survival~duration, data=d0male, pch=15
     , col="black" ,lwd=1, ylab="", xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(67,0.95,"0C",col="Black", cex=2)
lines(predFr~duration, data=d0male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d0female=subset(Fr,Temperature=="0" & sex=="female")
attach(d0female)
points(survival~duration, data=d0female, pch=17, col="Grey40",lwd=1)
lines(predFr~duration, data=d0female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#2.5
d2.5male=subset(Fr,Temperature=="2.5" & sex=="male")
attach(d2.5male)
plot(ylim=c(0,1), xlim=c(0,144),survival~duration, data=d2.5male, pch=15
     , col="black" ,lwd=1, ylab="Percentage survival", xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(134,0.95,"2.5C",col="Black", cex=2)
lines(predFr~duration, data=d2.5male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d2.5female=subset(Fr,Temperature=="2.5" & sex=="female")
attach(d2.5female)
points(survival~duration, data=d2.5female, pch=17, col="Grey40",lwd=1)
lines(predFr~duration, data=d2.5female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#5
d5male=subset(Fr,Temperature=="5" & sex=="male")
attach(d5male)
plot(ylim=c(0,1), xlim=c(0,360),survival~duration, data=d5male, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(335,0.95,"5C",col="Black", cex=2)
lines(predFr~duration, data=d5male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d5female=subset(Fr,Temperature=="5" & sex=="female")
attach(d5female)
points(survival~duration, data=d5female, pch=17, col="Grey40",lwd=1)
lines(predFr~duration, data=d5female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#7.5
d7.5male=subset(Fr,Temperature=="7.5" & sex=="male")
attach(d7.5male)
plot(ylim=c(0,1), xlim=c(0,720),survival~duration, data=d7.5male, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(670,0.95,"7.5C",col="Black", cex=2)
lines(predFr~duration, data=d7.5male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d7.5female=subset(Fr,Temperature=="7.5" & sex=="female")
attach(d7.5female)
points(survival~duration, data=d7.5female, pch=17, col="Grey40",lwd=1)
lines(predFr~duration, data=d7.5female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#Add legend 
legend("bottomright", legend=c("Males","Females"), col=c("black","darkgrey"),
       pch=c(15,17), pt.cex=c(1,1), cex=1.5)


#Lt50:
library(arm)
summary(model)

repet=sim(model,10000)
coef=coef(repet)
head(coef)
taux=0.5 
#Females
#-5C
intercept=coef[,1]
slope=coef[,7]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#-2.5C
intercept=coef[,1]+coef[,2]
slope=coef[,7]+coef[,9]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#0C
intercept=coef[,1]+coef[,3]
slope=coef[,7]+coef[,10]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#2.5C
intercept=coef[,1]+coef[,4]
slope=coef[,7]+coef[,11]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#5C
intercept=coef[,1]+coef[,5]
slope=coef[,7]+coef[,12]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#7.5C
intercept=coef[,1]+coef[,6]
slope=coef[,7]+coef[,13]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))

#Males
#-5C
intercept=coef [,1]+coef[,8]
slope=coef[,7]+coef[,19]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#-2.5C
intercept=coef [,1]+coef[,2]+coef[,8]+coef[,14]
slope=coef[,7]+coef[,9]+coef[,19]+coef[,20]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#0C
intercept=coef [,1]+coef[,3]+coef[,8]+coef[,15]
slope=coef[,7]+coef[,10]+coef[,19]+coef[,21]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#2.5C
intercept=coef [,1]+coef[,4]+coef[,8]+coef[,16]
slope=coef[,7]+coef[,11]+coef[,19]+coef[,22]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#5C
intercept=coef [,1]+coef[,5]+coef[,8]+coef[,17]
slope=coef[,7]+coef[,12]+coef[,19]+coef[,23]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#7.5C
intercept=coef [,1]+coef[,6]+coef[,8]+coef[,18]
slope=coef[,7]+coef[,13]+coef[,19]+coef[,24]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))