#Adults hot tolerance:
A<-read.table("tolerance chaud ad suzukii.txt", header=T)
A$survival=(A$n-A$dead)/A$n
Ch<-na.omit(A)
attach(Ch)

Temperature=as.factor(temperature)
yadCh<-cbind(Ch$n-Ch$dead,Ch$dead)
model<-glm(yadCh~Temperature*duration*sex, family=binomial(link=logit))
library(car)
Anova(model)

########## EFFECT PLOTS 
library(effects)
### All variables
plot(allEffects(model))
##### Variables and interactions
plot(effect("Temperature ",model),ylab="Survival") 
plot(effect("duration ",model),ylab="Survival")         
plot(effect("sex",model),ylab="Survival")  
plot(effect("Temperature:duration",model),ylab="Survival")                          
plot(effect("Temperature:sex ",model),ylab="Survival")                         
plot(effect("duration:sex",model),ylab="Survival")                      
plot(effect("Temperature:duration:sex",model),ylab="Survival")                   

Ch$predCh=predict(model, type="response")
predCh=as.numeric(unlist(Ch$predCh))

#################
#Plots:
x11()
par(mfrow=c(3,3), mar=c(4,4,1,1))
#30C: 
d30male=subset(Ch,Temperature=="30" & sex=="male")
attach(d30male)
plot(ylim=c(0,1), xlim=c(0,360),survival~duration, data=d30male, pch=15
     , col="black" ,lwd=1, ylab="Percentage survival", xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(345,0.95,"30C",col="Black", cex=2)
lines(predCh~duration, data=d30male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d30female=subset(Ch,Temperature=="30" & sex=="female")
attach(d30female)
points(survival~duration, data=d30female, pch=17, col="Grey40",lwd=1)
lines(predCh~duration, data=d30female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#31
d31male=subset(Ch,Temperature=="31" & sex=="male")
attach(d31male)
plot(ylim=c(0,1), xlim=c(0,250),survival~duration, data=d31male, pch=15
     , col="black" ,lwd=1, ylab="", xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(238,0.95,"31C",col="Black", cex=2)
lines(predCh~duration, data=d31male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d31female=subset(Ch,Temperature=="31" & sex=="female")
attach(d31female)
points(survival~duration, data=d31female, pch=17, col="Grey40",lwd=1)
lines(predCh~duration, data=d31female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#32
d32male=subset(Ch,Temperature=="32" & sex=="male")
attach(d32male)
plot(ylim=c(0,1), xlim=c(0,200),survival~duration, data=d32male, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(190,0.95,"32C",col="Black", cex=2)
lines(predCh~duration, data=d32male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d32female=subset(Ch,Temperature=="32" & sex=="female")
attach(d32female)
points(survival~duration, data=d32female, pch=17, col="Grey40",lwd=1)
lines(predCh~duration, data=d32female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#33
d33male=subset(Ch,Temperature=="33" & sex=="male")
attach(d33male)
plot(ylim=c(0,1), xlim=c(0,5),survival~duration, data=d33male, pch=15
     , col="black" ,lwd=1, ylab="Percentage survival", xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(4.75,0.95,"33C",col="Black", cex=2)
lines(predCh~duration, data=d33male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d33female=subset(Ch,Temperature=="33" & sex=="female")
attach(d33female)
points(survival~duration, data=d33female, pch=17, col="Grey40",lwd=1)
lines(predCh~duration, data=d33female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#34
d34male=subset(Ch,Temperature=="34" & sex=="male")
attach(d34male)
plot(ylim=c(0,1), xlim=c(0,3),survival~duration, data=d34male, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(2.85,0.95,"34C",col="Black", cex=2)
lines(predCh~duration, data=d34male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d34female=subset(Ch,Temperature=="34" & sex=="female")
attach(d34female)
points(survival~duration, data=d34female, pch=17, col="Grey40",lwd=1)
lines(predCh~duration, data=d34female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#35
d35male=subset(Ch,Temperature=="35" & sex=="male")
attach(d35male)
plot(ylim=c(0,1), xlim=c(0,2),survival~duration, data=d35male, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(1.9,0.95,"35C",col="Black", cex=2)
lines(predCh~duration, data=d35male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d35female=subset(Ch,Temperature=="35" & sex=="female")
attach(d35female)
points(survival~duration, data=d35female, pch=17, col="Grey40",lwd=1)
lines(predCh~duration, data=d35female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#37
d37male=subset(Ch,Temperature=="37" & sex=="male")
attach(d37male)
plot(ylim=c(0,1), xlim=c(0,2),survival~duration, data=d37male, pch=15
     , col="black" ,lwd=1, ylab="Percentage survival", xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(1.9,0.95,"37C",col="Black", cex=2)
lines(predCh~duration, data=d37male, type="l",lty=1, pch=20,col="black",lwd=2)
#Add females...
d37female=subset(Ch,Temperature=="37" & sex=="female")
attach(d37female)
points(survival~duration, data=d37female, pch=17, col="Grey40",lwd=1)
lines(predCh~duration, data=d37female, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#Add legend 
legend("right", legend=c("Males","Females"), col=c("black","darkgrey"),
       pch=c(15,17), pt.cex=c(1,1), cex=1.5)



#Lt50:
library(arm)
summary(model)

repet=sim(model,10000)
coef=coef(repet)
head(coef)
taux=0.5
#Females
#30C
intercept=coef[,1]
slope=coef[,8]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#31C
intercept=coef[,1]+coef[,2]
slope=coef[,8]+coef[,10]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#32C
intercept=coef[,1]+coef[,3]
slope=coef[,8]+coef[,11]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#33C
intercept=coef[,1]+coef[,4]
slope=coef[,8]+coef[,12]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#34C
intercept=coef[,1]+coef[,5]
slope=coef[,8]+coef[,13]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#35C
intercept=coef[,1]+coef[,6]
slope=coef[,8]+coef[,14]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#37C
intercept=coef[,1]+coef[,7]
slope=coef[,8]+coef[,15]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))

#Males
#30C
intercept=coef[,1]+coef[,9]
slope=coef[,8]+coef[,22]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#31C
intercept=coef[,1]+coef[,2]+coef[,9]+coef[,16]
slope=coef[,8]+coef[,10]+coef[,22]+coef[,23]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#32C
intercept=coef[,1]+coef[,3]+coef[,9]+coef[,17]
slope=coef[,8]+coef[,11]+coef[,22]+coef[,24]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#33C
intercept=coef[,1]+coef[,4]+coef[,9]+coef[,18]
slope=coef[,8]+coef[,12]+coef[,22]+coef[,25]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#34C
intercept=coef[,1]+coef[,5]+coef[,9]+coef[,19]
slope=coef[,8]+coef[,13]+coef[,22]+coef[,26]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#35C
intercept=coef[,1]+coef[,6]+coef[,9]+coef[,20]
slope=coef[,8]+coef[,14]+coef[,22]+coef[,27]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#37C
intercept=coef[,1]+coef[,7]+coef[,9]+coef[,21]
slope=coef[,8]+coef[,15]+coef[,22]+coef[,28]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))