#Pupae RH: 
D<-read.table("pupesRH.txt", header =T)
newD<-na.omit(D)
newD$survival=(1-newD$mortalite)
RH<-na.omit(newD)

###Cold:
a=subset(RH, temperature=="0")
b=subset(RH, temperature=="2.5")
c=subset(RH, temperature=="5")
d=subset(RH, temperature=="7.5")
RHfr<-rbind(a,b,c,d)
attach(RHfr)

Temperature=as.factor(RHfr$temperature)
yRHfr<-cbind(RHfr$emergeants,RHfr$n-RHfr$emergeants)
modelfr<-glm(yRHfr~Temperature*duration*rh, family=binomial(link=logit))
library(car)
Anova(modelfr)

########## EFFECT PLOTS 
library(effects)
### All variables
plot(allEffects(modelfr))
##### Variables and interactions
plot(effect("Temperature ",modelfr),ylab="Survival") 
plot(effect("duration ",modelfr),ylab="Survival")         
plot(effect("rh ",modelfr),ylab="Survival")
plot(effect("Temperature:duration",modelfr),ylab="Survival")                          
plot(effect("Temperature:rh",modelfr),ylab="Survival")  
plot(effect("duration:rh",modelfr),ylab="Survival")
plot(effect("Temperature:duration:rh",modelfr),ylab="Survival")

RHfr$predfr=predict(modelfr, type="response")
predfr=as.numeric(unlist(RHfr$predfr))


###Hot:
e=subset(RH, temperature=="32")
f=subset(RH, temperature=="33")
g=subset(RH, temperature=="34")
h=subset(RH, temperature=="35")
i=subset(RH, temperature=="37")
RHch<-rbind(e,f,g,h,i)
attach(RHch)

TEMPERATURE=as.factor(RHch$temperature)
yRHch<-cbind(RHch$emergeants,RHch$n-RHch$emergeants)
modelch<-glm(yRHch~TEMPERATURE*duration*rh, family=binomial(link=logit))
library(car)
Anova(modelch)

########## EFFECT PLOTS 
library(effects)
### All variables
plot(allEffects(modelch))
##### Variables and interactions
plot(effect("TEMPERATURE ",modelch),ylab="Survival") 
plot(effect("duration ",modelch),ylab="Survival")         
plot(effect("rh ",modelch),ylab="Survival")
plot(Effect(c("duration","TEMPERATURE"),modelch),ylab="Survival")                          
plot(effect("TEMPERATURE:rh",modelch),ylab="Survival")  
plot(effect("duration:rh",modelch),ylab="Survival")
plot(effect(c("duration","TEMPERATURE","rh"),modelch),ylab="Survival")

RHch$predch=predict(modelch, type="response")
predch=as.numeric(unlist(RHch$predch))

# Plots:
x11()
par(mfrow=c(3,3), mar=c(4,4,1,1))
#0
d0low=subset(RHfr,temperature=="0" & rh=="low")
attach(d0low)
plot(ylim=c(0,1), xlim=c(0,72),survival~duration, data=d0low, pch=15
     , col="black" ,lwd=1, ylab="Percentage survival", xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(69,0.95,"0C",col="Black", cex=2)
lines(predfr~duration, data=d0low, type="l",lty=1, pch=20,col="black",lwd=2)
#Add High RH
d0high=subset(RHfr,temperature=="0" & rh=="high")
attach(d0high)
points(survival~duration, data=d0high, pch=17, col="Grey40",lwd=1)
lines(predfr~duration, data=d0high, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#2.5
d2.5low=subset(RHfr,temperature=="2.5" & rh=="low")
attach(d2.5low)
plot(ylim=c(0,1), xlim=c(0,100),survival~duration, data=d2.5low, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(95,0.95,"2.5C",col="Black", cex=2)
lines(predfr~duration, data=d2.5low, type="l",lty=1, pch=20,col="black",lwd=2)
#Add High RH
d2.5high=subset(RHfr,temperature=="2.5" & rh=="high")
attach(d2.5high)
points(survival~duration, data=d2.5high, pch=17, col="Grey40",lwd=1)
lines(predfr~duration, data=d2.5high, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#5
d5low=subset(RHfr,temperature=="5" & rh=="low")
attach(d5low)
plot(ylim=c(0,1), xlim=c(0,120),survival~duration, data=d5low, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(115,0.95,"5C",col="Black", cex=2)
lines(predfr~duration, data=d5low, type="l",lty=1, pch=20,col="black",lwd=2)
#Add High RH
d5high=subset(RHfr,temperature=="5" & rh=="high")
attach(d5high)
points(survival~duration, data=d5high, pch=17, col="Grey40",lwd=1)
lines(predfr~duration, data=d5high, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#7.5
d7.5low=subset(RHfr,temperature=="7.5" & rh=="low")
attach(d7.5low)
plot(ylim=c(0,1), xlim=c(0,300),survival~duration, data=d7.5low, pch=15
     , col="black" ,lwd=1, ylab="Percentage survival", xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(280,0.95,"7.5C",col="Black", cex=2)
lines(predfr~duration, data=d7.5low, type="l",lty=1, pch=20,col="black",lwd=2)
#Add High RH
d7.5high=subset(RHfr,temperature=="7.5" & rh=="high")
attach(d7.5high)
points(survival~duration, data=d7.5high, pch=17, col="Grey40",lwd=1)
lines(predfr~duration, data=d7.5high, type="l",lty=2, pch=20,col="Grey40",lwd=2)

#32
d32low=subset(RHch,temperature=="32" & rh=="low")
attach(d32low)
plot(ylim=c(0,1), xlim=c(0,100),survival~duration, data=d32low, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(95,0.95,"32C",col="Black", cex=2)
lines(predch~duration, data=d32low, type="l",lty=1, pch=20,col="black",lwd=2)
#OAdd High RH
d32high=subset(RHch,temperature=="32" & rh=="high")
attach(d32high)
points(survival~duration, data=d32high, pch=17, col="Grey40",lwd=1)
lines(predch~duration, data=d32high, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#33
d33low=subset(RHch,temperature=="33" & rh=="low")
attach(d33low)
plot(ylim=c(0,1), xlim=c(0,50),survival~duration, data=d33low, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab=NA, mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(47,0.95,"33C",col="Black", cex=2)
lines(predch~duration, data=d33low, type="l",lty=1, pch=20,col="black",lwd=2)
#OAdd High RH
d33high=subset(RHch,temperature=="33" & rh=="high")
attach(d33high)
points(survival~duration, data=d33high, pch=17, col="Grey40",lwd=1)
lines(predch~duration, data=d33high, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#34
d34low=subset(RHch,temperature=="34" & rh=="low")
attach(d34low)
plot(ylim=c(0,1), xlim=c(0,50),survival~duration, data=d34low, pch=15
     , col="black" ,lwd=1, ylab="Percentage survival", xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(47,0.95,"34C",col="Black", cex=2)
lines(predch~duration, data=d34low, type="l",lty=1, pch=20,col="black",lwd=2)
#OAdd High RH
d34high=subset(RHch,temperature=="34" & rh=="high")
attach(d34high)
points(survival~duration, data=d34high, pch=17, col="Grey40",lwd=1)
lines(predch~duration, data=d34high, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#35
d35low=subset(RHch,temperature=="35" & rh=="low")
attach(d35low)
plot(ylim=c(0,1), xlim=c(0,25),survival~duration, data=d35low, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(23,0.95,"35C",col="Black", cex=2)
lines(predch~duration, data=d35low, type="l",lty=1, pch=20,col="black",lwd=2)
#OAdd High RH
d35high=subset(RHch,temperature=="35" & rh=="high")
attach(d35high)
points(survival~duration, data=d35high, pch=17, col="Grey40",lwd=1)
lines(predch~duration, data=d35high, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#37
d37low=subset(RHch,temperature=="37" & rh=="low")
attach(d37low)
plot(ylim=c(0,1), xlim=c(0,10),survival~duration, data=d37low, pch=15
     , col="black" ,lwd=1, ylab=NA, xlab="Exposure duration (h)", mgp=c(2.5, 1, 0), cex.axis=1.5, cex.lab=1.5)  
text(9,0.95,"37C",col="Black", cex=2)
lines(predch~duration, data=d37low, type="l",lty=1, pch=20,col="black",lwd=2)
#OAdd High RH
d37high=subset(RHch,temperature=="37" & rh=="high")
attach(d37high)
points(survival~duration, data=d37high, pch=17, col="Grey40",lwd=1)
lines(predch~duration, data=d37high, type="l",lty=2, pch=20,col="Grey40",lwd=2)
#... et une l?gende: 
legend("right", legend=c("low","high"), col=c("black","darkgrey"),
       pch=c(15,17), pt.cex=c(1,1), cex=1.5)
#######################################
#Lt50:
##Cold:
library(arm)
summary(modelfr)

repet=sim(modelfr,10000)
coef=coef(repet)
head(coef)
taux=0.5

#High RH:
#0C
intercept=coef[,1]
slope=coef[,5]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#2.5C
intercept=coef[,1]+coef[,2]
slope=coef[,5]+coef[,7]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#5C
intercept=coef[,1]+coef[,3]
slope=coef[,5]+coef[,8]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#7.5C
intercept=coef[,1]+coef[,4]
slope=coef[,5]+coef[,9]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))

#Low RH:
#0C
intercept=coef[,1]+coef[,6]
slope=coef[,5]+coef[,13]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#2.5C
intercept=coef[,1]+coef[,6]+coef[,2]+coef[,10]
slope=coef[,5]+coef[,13]+coef[,7]+coef[,14]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#5C
intercept=coef[,1]+coef[,6]+coef[,3]+coef[,11]
slope=coef[,5]+coef[,13]+coef[,8]+coef[,15]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#7.5C
intercept=coef[,1]+coef[,6]+coef[,4]+coef[,12]
slope=coef[,5]+coef[,13]+coef[,9]+coef[,16]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))

##Hot: 
summary(modelch)

repet=sim(modelch,10000)
coef2=coef(repet)
head(coef2)
taux=0.5 

#High RH:
#32C
intercept=coef2[,1]
slope=coef2[,6]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#33C
intercept=coef2[,1]+coef2[,2]
slope=coef2[,6]+coef2[,8]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#34C
intercept=coef2[,1]+coef2[,3]
slope=coef2[,6]+coef2[,9]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#35C
intercept=coef2[,1]+coef2[,4]
slope=coef2[,6]+coef2[,10]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#37C
intercept=coef2[,1]+coef2[,5]
slope=coef2[,6]+coef2[,11]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))

#Low RH:
#32C
intercept=coef2[,1]+coef2[,7]
slope=coef2[,6]+coef2[,16]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#33C
intercept=coef2[,1]+coef2[,7]+coef2[,2]+coef2[,12]
slope=coef2[,6]+coef2[,16]+coef2[,8]+coef2[,17]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#34C
intercept=coef2[,1]+coef2[,7]+coef2[,3]+coef2[,13]
slope=coef2[,6]+coef2[,16]+coef2[,9]+coef2[,18]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#35C
intercept=coef2[,1]+coef2[,7]+coef2[,4]+coef2[,14]
slope=coef2[,6]+coef2[,16]+coef2[,10]+coef2[,19]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))
#37C
intercept=coef2[,1]+coef2[,7]+coef2[,5]+coef2[,15]
slope=coef2[,6]+coef2[,16]+coef2[,11]+coef2[,20]
LT=(logit(taux)-intercept)/slope

mean(LT);sd(LT);quantile(LT,p=c(0.025,0.975))