#Female's cold tolerance
d<-read.table("tolerance froid ad suzukii.txt", header=T)
d$time<-(d$duree)/24
f=subset(d,sexe=="female")
f$survie=(f$n-f$mortsL)/f$n
fFr<-na.omit(f)
attach(fFr)

yfFr<-cbind(fFr$n-fFr$mortsL,fFr$mortsL)
model<-glm(yfFr~temperature*time, family=binomial(link=logit))
library(car)
Anova

x1seq=seq(range(temperature)[1],range(temperature)[2],length=30)
x2seq=seq(range(time)[1],range(time)[2],length=30)

predtridi=function(a,b){
  predict(model,newdata=data.frame(temperature=a,time=b),type="response")
  
}
o<-outer(x1seq,x2seq,predtridi)

p=persp(x1seq,x2seq,o,axes=T,r=3,xlim=c(-5,7.5),zlim=c(0,1),theta=210,phi=25, 
        border="darkgrey",xlab="Temperature (C)", ylab="
        Time (days)", 
        sub="Females", zlab="
        Percentage survival",ticktype="detailed",col="lightgrey" ,
        shade = 0.5,ltheta = 90, lphi = 180 )
points=trans3d(temperature,time,(fFr$n-fFr$mortsL)/fFr$n,pmat=p)
points(points, pch=20)
text(trans3d(5.5,30,0.95,p), "Females")