#Pupae's cold tolerance
C<-read.table("tolerance pupes froid suzukii.txt", header=T)
Pfr<-na.omit(C)
attach(Pfr)
Pfr$time<-duree/24
attach(Pfr)

ypfr<-cbind(Pfr$emergeants,Pfr$n-Pfr$emergeants)
model<-glm(ypfr~temperature*time, family=binomial(link=logit))
library(car)
Anova(model)

x1seq=seq(range(temperature)[1],range(temperature)[2],length=30)
x2seq=seq(range(time)[1],range(time)[2]+range(time[2]),length=30)

predtridi=function(a,b){
  predict(model,newdata=data.frame(temperature=a,time=b),type="response")
  
}
o<-outer(x1seq,x2seq,predtridi)

p=persp(x1seq,x2seq,o,axes=T,r=3,xlim=c(-5,7.5),zlim=c(0,1),theta=210,phi=25, 
        border="darkgrey",xlab="Temperature (C)", ylab="
        Time (days)", 
        sub="Pupae", zlab="
        Percentage survival",ticktype="detailed",col="lightgrey" ,
        shade = 0.5,ltheta = 90, lphi = 180 )
points=trans3d(temperature,time,emergeants/n,pmat=p)
points(points, pch=20)
text(trans3d(5.5,30,0.95,p), "Pupae")
