#Pupae's hot tolerance
C<-read.table("tolerance pupes chaud suzukii.txt", header=T)
Pch<-na.omit(C)
attach(Pch)
Pch$time<-duree/24
attach(Pch)

yPch<-cbind(Pch$emergeants,Pch$n-Pch$emergeants)
model<-glm(yPch~temperature*time, family=binomial(link=logit))
library(car)
Anova(model)

x1seq=seq(range(temperature)[1],range(temperature)[2],length=30)
x2seq=seq(range(time)[1],range(time)[2],length=30)

predtridi=function(a,b){
  predict(model,newdata=data.frame(temperature=a,time=b),type="response")
  
}
o<-outer(x1seq,x2seq,predtridi)

p=persp(x1seq,x2seq,o,axes=T,r=3,xlim=c(30,37),zlim=c(0,1),theta=120,phi=25, border="darkgrey",xlab="
        Temperature (C)", ylab="Time (days)", sub="Pupae", zlab="
        Percentage survival",ticktype="detailed",col="lightgrey" ,shade = 0.5)
points=trans3d(temperature,time,emergeants/n,pmat=p)
points(points, pch=20)

text(trans3d(37,3.5,0.95,p), "Pupae")