#Cold tolerance
  ## Low RH: 
RH<-read.table("pupesRH.txt", header =T)
RH$time<-(RH$duree)/24
L=subset(RH,rh=="low")
L$survie=(1-L$mortalite)

RH0<-subset(L, temperature==0)
RH2.5<-subset(L, temperature==2.5)
RH5<-subset(L, temperature==5)
RH7.5<-subset(L, temperature==7.5)
RHfroid<-rbind(RH0, RH2.5, RH5, RH7.5)   

Low<-na.omit(RHfroid)
attach(Low)

yLow<-cbind(emergeants,n-emergeants)
model<-glm(yLow~temperature*time, family=binomial(link=logit))
library(car)
Anova(model)

x1seq=seq(range(temperature)[1],range(temperature)[2],length=30)
x2seq=seq(range(time)[1],range(time)[2],length=30)

predtridiL=function(a,b){
  predict(model,newdata=data.frame(temperature=a,time=b),type="response")
  
}
oL<-outer(x1seq,x2seq,predtridiL)

## High RH: 
RH<-read.table("pupesRH.txt", header =T)
RH$time<-(RH$duree)/24
H=subset(RH,rh=="high")
H$survie=(1-L$mortalite)

RH0H<-subset(H, temperature==0)
RH2.5H<-subset(H, temperature==2.5)
RH5H<-subset(H, temperature==5)
RH7.5H<-subset(H, temperature==7.5)
RHfroidH<-rbind(RH0H, RH2.5H, RH5H, RH7.5H)   

High<-na.omit(RHfroidH)
attach(High)

yHigh<-cbind(emergeants,n-emergeants)
model2<-glm(yHigh~temperature*time, family=binomial(link=logit))
library(car)
Anova(model2)

x1seq=seq(range(temperature)[1],range(temperature)[2],length=30)
x2seq=seq(range(time)[1],range(time)[2],length=30)

predtridiH=function(a,b){
  predict(model2,newdata=data.frame(temperature=a,time=b),type="response")
  
}
oH<-outer(x1seq,x2seq,predtridiH)

##Plot:
par(mfrow=c(2,2), mar=c(1,2,1,1))
p=persp(x1seq,x2seq,oL,axes=T,r=3,xlim=c(0,7.5),zlim=c(0,1),theta=210,phi=25, 
        border="darkgrey",xlab="Temperature (°C)", ylab="
        Time (days)", 
        sub="Low", zlab="
        Percentage survival",ticktype="detailed",col="lightgrey" ,
        shade =0.5, ltheta = 90, lphi = 180 )
points=trans3d(temperature,time,Low$emergeants/Low$n,pmat=p)
points(points, pch=20)
library(rgl)
text(trans3d(6,12,0.95,p), "Low RH") 


p=persp(x1seq,x2seq,oH,axes=T,r=3,xlim=c(0,7.5),zlim=c(0,1),theta=210,phi=25, 
        border="darkgrey",xlab="Temperature (C)", ylab="
        Time (days)", 
        sub="High", zlab="
        Percentage survival",ticktype="detailed",col="lightgrey" ,
        shade =0.5, ltheta = 90, lphi = 180 )
points=trans3d(temperature,time,High$emergeants/High$n,pmat=p)
points(points, pch=20)
text(trans3d(6,12,0.95,p), "High RH")

############### Hot: 
## Low RH: 
RH32<-subset(L, temperature==32)
RH33<-subset(L, temperature==33)
RH34<-subset(L, temperature==34)
RH35<-subset(L, temperature==35)
RH37<-subset(L, temperature==37)
RHchaud<-rbind(RH32, RH33, RH34, RH35, RH37)   

LowC<-na.omit(RHchaud)
attach(LowC)

yLowC<-cbind(emergeants,n-emergeants)
model3<-glm(yLowC~temperature*time, family=binomial(link=logit))
library(car)
Anova(model3)

x1seq=seq(range(temperature)[1],range(temperature)[2],length=30)
x2seq=seq(range(time)[1],range(time)[2],length=30)

predtridiLC=function(a,b){
  predict(model3,newdata=data.frame(temperature=a,time=b),type="response")
  
}
oLC<-outer(x1seq,x2seq,predtridiLC)

## High RH: 
RH32H<-subset(H, temperature==32)
RH33H<-subset(H, temperature==33)
RH34H<-subset(H, temperature==34)
RH35H<-subset(H, temperature==35)
RH37H<-subset(H, temperature==37)
RHChaudH<-rbind(RH32H, RH33H, RH34H, RH35H, RH37H)   

HighC<-na.omit(RHChaudH)
attach(HighC)

yHighC<-cbind(emergeants,n-emergeants)
model4<-glm(yHighC~temperature*time, family=binomial(link=logit))
library(car)
Anova(model4)

x1seq=seq(range(temperature)[1],range(temperature)[2],length=30)
x2seq=seq(range(time)[1],range(time)[2],length=30)

predtridiHC=function(a,b){
  predict(model4,newdata=data.frame(temperature=a,time=b),type="response")
  
}
oHC<-outer(x1seq,x2seq,predtridiHC)

##Plot:
p=persp(x1seq,x2seq,oLC,axes=T,r=3,xlim=c(32,37),zlim=c(0,1),theta=110,phi=25, 
        border="darkgrey",xlab="
        Temperature (°C)", ylab="Time (days)", 
        sub="Low", zlab="
        Percentage survival",ticktype="detailed",col="lightgrey" ,
        shade =0.5, ltheta = 90, lphi = 180 )
points=trans3d(temperature,time,LowC$emergeants/LowC$n,pmat=p)
points(points, pch=20)
text(trans3d(37,3.5,0.95,p), "Low RH")

p=persp(x1seq,x2seq,oHC,axes=T,r=3,xlim=c(32,37),zlim=c(0,1),theta=110,phi=25, 
        border="darkgrey",xlab="
        Temperature (C)", ylab="Time (days)", 
        sub="High", zlab="
        Percentage survival",ticktype="detailed",col="lightgrey" ,
        shade =0.5, ltheta = 90, lphi = 180 )
points=trans3d(temperature,time,High$emergeants/HighC$n,pmat=p)
points(points, pch=20)
text(trans3d(37,3.5,0.95,p), "High RH")